#include "../include/stubs.h"
#include "../include/ioctl.h"

#include <stdio.h>


BOOL LCloseHandle(HANDLE hDevice)
{
	#ifdef LCOMP_LINUX
		return close(hDevice);
	#else
		return !CloseHandle(hDevice);
	#endif
}

HANDLE LCreateFile(const char *szDrvName)
{
	#ifndef LCOMP_LINUX
	   ULONG dwCreation = OPEN_EXISTING;
		ULONG dwFlags = FILE_FLAG_OVERLAPPED;
   	return CreateFile(szDrvName, GENERIC_WRITE | GENERIC_READ, 0, // single use only no sharing
                        NULL, dwCreation, dwFlags, NULL);
	#else
		return open(szDrvName, O_RDWR);
	#endif

}

// in linux define handle as int
// maximum read/write size is 4096 byte
// see source for limitations...
BOOL LDeviceIoControl(HANDLE hDevice,
                       ULONG dwIoControlCode,
                       LPVOID lpInBuffer,
                       ULONG nInBufferSize,
                       LPVOID lpOutBuffer,
                       ULONG nOutBufferSize,
                       PULONG lpBytesReturned,
                       LPOVERLAPPED lpOverlapped)
{
#ifdef LCOMP_LINUX
   BOOL status = FALSE;
   IOCTL_BUFFER ibuf;
   unsigned int i;
   do
   {
      if(nInBufferSize > 4096) { printf("err");break; }
      if(nOutBufferSize > 4096) { printf("err1");break; }

      if(lpOutBuffer)
      {
         ibuf.outSize = nOutBufferSize;
         for(i=0;i<nOutBufferSize;i++) ibuf.outBuffer[i] = ((PUCHAR)lpOutBuffer)[i];
      }

      if(lpInBuffer)
      {
	      for(i=0;i<nInBufferSize;i++) ibuf.inBuffer[i] = ((PUCHAR)lpInBuffer)[i];
  		   ibuf.inSize = nInBufferSize;
      }

      if(ioctl((int)hDevice, dwIoControlCode, &ibuf)) break;
      if(lpOutBuffer) for(i=0;i<nOutBufferSize;i++) ((PUCHAR)lpOutBuffer)[i] = ibuf.outBuffer[i];
      *lpBytesReturned = ibuf.outSize;
      status = TRUE;
   } while (status==FALSE);
   return status;
#else
   return DeviceIoControl(hDevice, dwIoControlCode, lpInBuffer, nInBufferSize,
                          lpOutBuffer, nOutBufferSize, lpBytesReturned, lpOverlapped);
#endif
}
